Subject: Re: problems in linux-next (Was: Re: linux-next: Tree for December 1)

From: Tejun Heo <[email-masked]>
Date: Thu, 03 Dec 2009 07:16:07 +0900

On 12/02/2009 11:55 PM, Christoph Lameter wrote:
> On Wed, 2 Dec 2009, Tejun Heo wrote:
> 
>> This isn't usual alignment.  struct work_struct has one data fields
>> which is overloaded for two purposes.  Lower few bits are used to
>> carry flags while upper bits are used to point to sruct
>> cpu_workqueue_struct.  So, the number of available bits for flags are
>> determined by the alignment of cpu_workqueue_struct.  Memory usage for
> 
> The default mininum slab alignment in UP is 8 bytes which means you can
> use 3 bits. And as far as I can see only the lower two bits are used. You
> still have one bit leftover. (current upstream that is did not check if
> you modified it).

For colored workqueue flushing, it ends up using more than three bits.
I haven't decided it fully yet but total of six or seven depending on
how many colors are used.  So, we need forced alignment anyway.

Thanks.

-- 
tejun